<?php
/**
 * api: php
 * title: SQL config backend
 * description: uses a slow SQL storage backend for config settings
 * priority: never
 * category: library
 * version: 0.0
 * depends: libconfigedit
 * config:
 *     <sql table="wp_config" name="config_standard" value="1" type="int" title="enable config standard" />
 *  
 *  Example plugin that departs from the libconfigedit scheme
 *  in using a database rather than configuration _files_.
 *  It's meant as example that the plugin meta data standard
 *  and <var> settings are not inherently bound to files.
 *
 *  Uses the WordPress config data table format:
         CREATE TABLE $wpdb->options (
           option_id
           blog_id
           option_name
           option_value
           autoload default 'yes',
 * 
 *  This variant only provides for variable configuration, due
 *  to the example WP database layout. Other schemes could have
 *  a plugin table too (Serendipity), or it could be hacked in.
 *  OTOH this allows variable names to be simply alphanumeric,
 *  they don't have to be arrays[] as with libconfigedit.
 *
 *  IT'S JUST A STUB. NOT TESTED OR USE READY. NEED YOUR OWN DB
 *  SCHEME.
 *  Basically it overrides ->read() and ->analyse() and ->write().
 *  The line oriented modifiers remain, values are simply stored
 *  as-is in the ->cf[] array.
 */



class generic_config_edit_ini extends generic_config_edit {



   # probably don't need to override these
   # the line-oriented defaults don't hurt
   #
  // function add($ctype=0, $name, $value, $sort=0) 
  // function remove($name, $commentout=1, $i=0) 



   /**
    * stub
    *
    */
   function generic_config_edit($dsn="mysql://localhost;table=wp_config;user=;password=") {
      $this->read();
   }


   /**
    * rather override:
    * 
    */
   function read() {

      // read
      $this->origcf = array();
      $r = mysql_query("SELECT option_name AS name, option_value AS value FROM wp_config");
      while ($row = mysql_fetch_array($r)) {
         $this->orgicf[] = $row;  // ($row["name"], $row["value"])
      }

      // analyse
      $this->analyse($this->origcf);
 
      // nop:
      # $this->clean_doublettes();

      //$this->determine_config_block();   // $start + $end
      $this->start = 0;
      $this->end = count($this->cf) - 1;
   }


   /**
    * simple here
    * 
    */
   function analyse($vars) {
      foreach ($vars as $row) {
         $cf[] = new generic_config_line($ctype=2, $name=$row["name"], $value=$row["value"], $sort=0, $orig="", $trail="");
      }
   }


   /**
    * and write back:
    */
   function write($filename="") {
      foreach ($this->cf as $row) {
         $name = $this->varname_to_php_expression($row->name);
         $value = mysql_real_escape_string($row->value);
         mysql_query("INSERT OR UPDATE INTO wp_config (name, value, blog_id, autoload)
         VALUES ('$name', '$value', 0, 'yes')");
      }
   }

   


   /**
    * instead of line commands, just store $name and $value as-is
    */
   function new_config_command($ctype, $name, $value) {
      return "$name=$value";  # fake config text line
   }



   /**
    * stub here
    */
   function varname_to_php_expression($name) {
      return preg_replace("/[^\w]+/", "_", $name);
   }



   /**
    * stub, but could mysql_real_escape_string already here
    */
   function value_to_php_expression($value) {   
      return $value;
   }



   /**
    * filter variable/constant value (remove syntax breaking newlines, e.g.)
    */
   function clean_value($v) {
      $v = preg_replace("/[\r\n\001-\007\011-\037\'\"\\\$]/", " ", $v);
      $v= strtr($v, "\000", " ");
      return $v;
   }


}







?>